<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>LibraryMgr: IOStream Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibraryMgr
   &#160;<span id="projectnumber">0.4</span>
   </div>
   <div id="projectbrief">Library manager desktop app</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('class_i_o_stream.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="class_i_o_stream-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">IOStream Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_i_o_stream_8h_source.html">IOStream.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:af387fc9782b78d559e9e123f8d4b0378"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#af387fc9782b78d559e9e123f8d4b0378">DATA_FILES</a> { <b>USERS</b> = 0, 
<b>BOOKS</b> = 1, 
<b>AUTH</b> = 2
 }</td></tr>
<tr class="separator:af387fc9782b78d559e9e123f8d4b0378"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aa59f4d583a53d0084d42665c80373acd"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#aa59f4d583a53d0084d42665c80373acd">IOStream</a> ()</td></tr>
<tr class="separator:aa59f4d583a53d0084d42665c80373acd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac3e47a49464ceb37fcc7d8813883ba27"><td class="memItemLeft" align="right" valign="top">const QString&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#ac3e47a49464ceb37fcc7d8813883ba27">getAppDirPath</a> () const </td></tr>
<tr class="separator:ac3e47a49464ceb37fcc7d8813883ba27"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd040bf507604b891aa1cae4d621aad7"><td class="memItemLeft" align="right" valign="top">const QString&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#acd040bf507604b891aa1cae4d621aad7">getUsersDataFilePath</a> () const </td></tr>
<tr class="separator:acd040bf507604b891aa1cae4d621aad7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0e283e64eadd042e415ee8a0a8bd793"><td class="memItemLeft" align="right" valign="top">const QString&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#ad0e283e64eadd042e415ee8a0a8bd793">getBooksDataFilePath</a> () const </td></tr>
<tr class="separator:ad0e283e64eadd042e415ee8a0a8bd793"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a864edcac5f83b8eda0d707354dd72b84"><td class="memItemLeft" align="right" valign="top">const QString&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a864edcac5f83b8eda0d707354dd72b84">getAuthDataFilePath</a> () const </td></tr>
<tr class="separator:a864edcac5f83b8eda0d707354dd72b84"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a419b2221abeaa4756de0be3e117b5fd8"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_user.html">User</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a419b2221abeaa4756de0be3e117b5fd8">readUsers</a> (QString filePath) const </td></tr>
<tr class="separator:a419b2221abeaa4756de0be3e117b5fd8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a726b753d942c4053772f1f4753481076"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a726b753d942c4053772f1f4753481076">readBooks</a> (QString filePath) const </td></tr>
<tr class="separator:a726b753d942c4053772f1f4753481076"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99506021a117fd34df0f622bd33545f2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="class_o_auth.html">OAuth</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a99506021a117fd34df0f622bd33545f2">readOAuth</a> (QString filePath) const </td></tr>
<tr class="separator:a99506021a117fd34df0f622bd33545f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1298f34f7ce16078d10823e9a6784d53"><td class="memItemLeft" align="right" valign="top">const QJsonObject&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a1298f34f7ce16078d10823e9a6784d53">readFileToJson</a> (QString filePath) const </td></tr>
<tr class="separator:a1298f34f7ce16078d10823e9a6784d53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ca580f07f8515b4a2e2763dcf7adc01"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a4ca580f07f8515b4a2e2763dcf7adc01">writeUsers</a> (std::vector&lt; <a class="el" href="class_user.html">User</a> * &gt; users, QString filePath) const </td></tr>
<tr class="separator:a4ca580f07f8515b4a2e2763dcf7adc01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acce186afe3fd4a4a11a1499d593aa8d1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#acce186afe3fd4a4a11a1499d593aa8d1">writeBooks</a> (std::vector&lt; <a class="el" href="class_book.html">Book</a> &gt; books, QString filePath) const </td></tr>
<tr class="separator:acce186afe3fd4a4a11a1499d593aa8d1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a40e2bd3e025d41de39c18e72d853b013"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#a40e2bd3e025d41de39c18e72d853b013">writeOAuth</a> (<a class="el" href="class_o_auth.html">OAuth</a> oauth, QString filePath) const </td></tr>
<tr class="separator:a40e2bd3e025d41de39c18e72d853b013"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aae24a6ac3c331a95e8438e7616eefa3b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_i_o_stream.html#aae24a6ac3c331a95e8438e7616eefa3b">writeFileAsJson</a> (QJsonDocument jsonData, QString filePath) const </td></tr>
<tr class="separator:aae24a6ac3c331a95e8438e7616eefa3b"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Copyright 2016-2017 Stefano Fogarollo</p>
<p>Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at</p>
<p><a href="http://www.apache.org/licenses/LICENSE-2.0">http://www.apache.org/licenses/LICENSE-2.0</a></p>
<p>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. Provides methods to load/save app files </p>
</div><h2 class="groupheader">Member Enumeration Documentation</h2>
<a class="anchor" id="af387fc9782b78d559e9e123f8d4b0378"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="class_i_o_stream.html#af387fc9782b78d559e9e123f8d4b0378">IOStream::DATA_FILES</a></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Possible data to read </p>

</div>
</div>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aa59f4d583a53d0084d42665c80373acd"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">IOStream::IOStream </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Streamer for app </p><dl class="section return"><dt>Returns</dt><dd>IO app streams manager </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="ac3e47a49464ceb37fcc7d8813883ba27"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QString IOStream::getAppDirPath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets path to app data directory </p><dl class="section return"><dt>Returns</dt><dd>path to app data directory </dd></dl>

</div>
</div>
<a class="anchor" id="a864edcac5f83b8eda0d707354dd72b84"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QString IOStream::getAuthDataFilePath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets path to app authentications database </p><dl class="section return"><dt>Returns</dt><dd>path to app authentications database </dd></dl>

</div>
</div>
<a class="anchor" id="ad0e283e64eadd042e415ee8a0a8bd793"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QString IOStream::getBooksDataFilePath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets path to app books database </p><dl class="section return"><dt>Returns</dt><dd>path to app books database </dd></dl>

</div>
</div>
<a class="anchor" id="acd040bf507604b891aa1cae4d621aad7"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QString IOStream::getUsersDataFilePath </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets path to app users database </p><dl class="section return"><dt>Returns</dt><dd>path to app users database </dd></dl>

</div>
</div>
<a class="anchor" id="a726b753d942c4053772f1f4753481076"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; <a class="el" href="class_book.html">Book</a> &gt; IOStream::readBooks </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Retrieves books data from database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filePath</td><td>path of file to read </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list of books in database </dd></dl>

</div>
</div>
<a class="anchor" id="a1298f34f7ce16078d10823e9a6784d53"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QJsonObject IOStream::readFileToJson </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Reads file in json format. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filePath</td><td>path of file to read </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>json representation of file. </dd></dl>

</div>
</div>
<a class="anchor" id="a99506021a117fd34df0f622bd33545f2"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_o_auth.html">OAuth</a> IOStream::readOAuth </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Retrieves credentials data from database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filePath</td><td>path of file to read </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list of user credentials database </dd></dl>

</div>
</div>
<a class="anchor" id="a419b2221abeaa4756de0be3e117b5fd8"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt; <a class="el" href="class_user.html">User</a> * &gt; IOStream::readUsers </td>
          <td>(</td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Retrieves users data from database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">filePath</td><td>path of file to read </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>list of users in database </dd></dl>

</div>
</div>
<a class="anchor" id="acce186afe3fd4a4a11a1499d593aa8d1"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IOStream::writeBooks </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="class_book.html">Book</a> &gt;&#160;</td>
          <td class="paramname"><em>books</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves books data to database </p>

</div>
</div>
<a class="anchor" id="aae24a6ac3c331a95e8438e7616eefa3b"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IOStream::writeFileAsJson </td>
          <td>(</td>
          <td class="paramtype">QJsonDocument&#160;</td>
          <td class="paramname"><em>jsonData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves json data in json format. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">jsonData</td><td>data to save. </td></tr>
    <tr><td class="paramname">filePath</td><td>path of file to write </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a40e2bd3e025d41de39c18e72d853b013"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IOStream::writeOAuth </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_o_auth.html">OAuth</a>&#160;</td>
          <td class="paramname"><em>oauth</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves user credentials data to database </p>

</div>
</div>
<a class="anchor" id="a4ca580f07f8515b4a2e2763dcf7adc01"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void IOStream::writeUsers </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; <a class="el" href="class_user.html">User</a> * &gt;&#160;</td>
          <td class="paramname"><em>users</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">QString&#160;</td>
          <td class="paramname"><em>filePath</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves users data to database </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>streams/IOStream/<a class="el" href="_i_o_stream_8h_source.html">IOStream.h</a></li>
<li>streams/IOStream/IOStream.cpp</li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="class_i_o_stream.html">IOStream</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
